# Open Source License
# Copyright (c) 2019 Nomadic Labs. <contact@nomadic-labs.com>

# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:

# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.

main0.ml: extraction.vo

zarith.ml:
	echo "include Z" > $@

zarith.mli:
	echo "include module type of Z with type t = Z.t" > $@

%.ml: %.ml.hand-written
	cp $< $@

%.mli: %.mli.hand-written
	cp $< $@

post-all:: michocoq.ml extraction.vo zarith.ml zarith.mli uint63.ml uint63.mli stdlibInt.mli
	ocamlbuild -package zarith michocoq.native

clean-extracted:
	rm -f *.ml *.mli *.cmi *.cmo *.native

cleanall::
	make clean-extracted
